import Migration from "../../db/Migration";
import {Connection} from "mysql";

export default class CreateMagicLinksTable extends Migration {
    async install(connection: Connection): Promise<void> {
        await this.query('CREATE TABLE magic_links(' +
            'id INT NOT NULL AUTO_INCREMENT,' +
            'session_id CHAR(32) UNIQUE NOT NULL,' +
            'email VARCHAR(254) NOT NULL,' +
            'token CHAR(96) NOT NULL,' +
            'action_type VARCHAR(64) NOT NULL,' +
            'original_url VARCHAR(1745) NOT NULL,' +
            'generated_at DATETIME NOT NULL,' +
            'authorized BOOLEAN NOT NULL,' +
            'PRIMARY KEY(id)' +
            ')', connection);
    }

    async rollback(connection: Connection): Promise<void> {
        await this.query('DROP TABLE magic_links', connection);
    }

}