import Migration from "../db/Migration";
import {Connection} from "mysql";

/**
 * Must be the first migration
 */
export default class CreateLogsTable extends Migration {
    async install(connection: Connection): Promise<void> {
        await this.query('CREATE TABLE logs(' +
            'id INT NOT NULL AUTO_INCREMENT,' +
            'level TINYINT UNSIGNED NOT NULL,' +
            'message TEXT NOT NULL,' +
            'log_id BINARY(16),' +
            'error_name VARCHAR(128),' +
            'error_message VARCHAR(512),' +
            'error_stack TEXT,' +
            'created_at DATETIME NOT NULL DEFAULT NOW(),' +
            'PRIMARY KEY (id)' +
            ')', connection);
    }

    async rollback(connection: Connection): Promise<void> {
        await this.query('DROP TABLE logs', connection);
    }
}